// run at YOUR OWN RISK, it shouldnt but it may damage your device and you!
#include <stdio.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>

#define BASE_ADDRESS 0x48050000


// MMCHS_HCTL
unsigned int mmcsh1_phy_addr = 0x4809C128;
unsigned int mmcsh2_phy_addr = 0x480B4128;
unsigned int mmcsh3_phy_addr = 0x480AD128;

// MMCHS_CAPA
unsigned int mmcsh1_capa_phy_addr = 0x4809C140;
unsigned int mmcsh2_capa_phy_addr = 0x480B4140;
unsigned int mmcsh3_capa_phy_addr = 0x480AD140;



#include <limits.h>

char * int2bin(int i)
{
  size_t bits = (sizeof(int)) * CHAR_BIT;

  char * str = malloc(bits + 1);
  if(!str) return NULL;
  str[bits] = 0;

  // type punning because signed shift is implementation-defined
  unsigned u = *(unsigned *)&i;
  for(; bits--; u >>= 1){
    str[bits] = u & 1 ? '1' : '0';      
  }
  
  return str;
}


void print_int(unsigned int aint){
  printf("\n%s\n31      23      15      7      0\n", int2bin(aint));
}

unsigned int read_abs(char* name, unsigned int addr, unsigned int* avalue){
  int mem;
  unsigned int *value = malloc(sizeof(int));
  unsigned int value_read;
  void *ptr;
  int mapsize = 8192;
  /* get page size */
  mapsize = getpagesize();

  int mybase = (addr / mapsize) * mapsize;

  int myoffset = addr - mybase;

  //printf("addr %x -> mybase %x + offset %x\n", addr , mybase, myoffset);

  /* Open /dev/mem */
  if ((mem = open ("/dev/mem", O_RDWR | O_SYNC)) == -1)
    fprintf(stderr, "Cannot open /dev/mem\n"), exit(1);


  //ptr = mmap (0, 8192, PROT_READ|PROT_WRITE, MAP_SHARED, mem, BASE_ADDRESS);
  //ptr = mmap (0, mapsize, PROT_READ|PROT_WRITE, MAP_SHARED, mem, mybase);
  ptr = mmap (0, mapsize, PROT_READ|PROT_WRITE, MAP_SHARED, mem, mybase);

  if(ptr == (void *) -1) {
    printf("Memory map failed for %x. error %i\n", addr, ptr);
    perror("mmap");

  }else{
    //printf("Memory mapped to %x\n", ptr);

    //value = (unsigned int*)(ptr + myoffset);
    value = (ptr + myoffset);
    printf("reading mapped addr %x\n", value);
    //*value = 479*799*3-4;
    value_read = *value;
    printf("value %x = %s\n%s\n31      23      15      7      0\n", value, name ,int2bin(value_read));

    *avalue = value_read;
    munmap(ptr, mapsize);
  }
  close(mem);
  
  //return *value;
  return 0;
}

unsigned int read_abs_uint(char *name, unsigned int addr, unsigned int* ret){
  printf("ret addr: %x v: %x\n", ret ,*ret);
  return read_abs(name, addr, ret);
}

unsigned int write_abs_uint(char *name, unsigned int addr, unsigned int avalue){
  int mem;
  unsigned int *value;
  void *ptr;
  int mapsize = 8192;
  /* get page size */
  mapsize = getpagesize();

  int mybase = (addr / mapsize) * mapsize;

  int myoffset = addr - mybase;

  //printf("addr %x -> mybase %x + offset %x\n", addr , mybase, myoffset);

  /* Open /dev/mem */
  if ((mem = open ("/dev/mem", O_RDWR | O_SYNC)) == -1)
    fprintf(stderr, "Cannot open /dev/mem\n"), exit(1);


  //ptr = mmap (0, 8192, PROT_READ|PROT_WRITE, MAP_SHARED, mem, BASE_ADDRESS);
  //ptr = mmap (0, mapsize, PROT_READ|PROT_WRITE, MAP_SHARED, mem, mybase);
  ptr = mmap (0, mapsize, PROT_READ|PROT_WRITE, MAP_SHARED, mem, mybase);

  if(ptr == (void *) -1) {
    printf("Memory map failed for %x. error %i\n", addr, ptr);
    perror("mmap");

  }else{
    //printf("Memory mapped to %x\n", ptr);

    //value = (unsigned int*)(ptr + myoffset);
    value = (ptr + myoffset);
    printf("try writing to %s to mapped %x", name, value);
    print_int(avalue);

    *value = avalue;
    printf("writing %x to mapped addr%x\n", avalue, value);
    print_int(*value);
    //*value = 479*799*3-4;
    //*value = avalue;
    //printf("addr %x = now %x (%i)\n", addr, *value, *value);

    munmap(ptr, mapsize);
  }
  close(mem);
  
  //return *value;
  return 0;
}



void init(){
  unsigned int* ret = malloc(sizeof(int));
  unsigned int gpio=0;
  *ret = 16;
  //printf("ret addr: %x v: %x\n", ret ,*ret);
  read_abs_uint("PRCM.CM_ICLKEN1_CORE", 0x48004A10, ret);
  // write_abs_uint("PRCM.CM_ICLKEN1_CORE", 0x48004A10, *ret | 0x10111111);
  write_abs_uint("PRCM.CM_ICLKEN1_CORE", 0x48004A10, *ret | 0x01000000);
  read_abs_uint("PRCM.CM_FCLKEN1_CORE", 0x48004A00, ret);
  write_abs_uint("PRCM.CM_FCLKEN1_CORE", 0x48004A00, *ret | 0x01000000);
  
  // reset
  if (1){
    write_abs_uint("MMCHS1.MMCHS_SYSCONFIG", 0x4809C010, 0x00000002);

    // leave testmode
    // write_abs_uint("MMCHS1.MMCHS_CON", 0x4809C02C, *ret & (~0x8));
    // wait for reset finish
    for (read_abs_uint("MMCHS1.MMCHS_SYSSTATUS", 0x4809C014, ret); (*ret & 1) != 1;usleep(100000))
      read_abs_uint("MMCHS1.MMCHS_SYSSTATUS", 0x4809C014, ret);

    read_abs_uint("MMCHS1.MMCHS_CAPA", 0x4809C140, ret); // , current_value | 0x06000000
    //write_abs_uint("MMCHS1.MMCHS_CAPA", 0x4809C140, *ret | 0x06000000); // 1.8V(on) 3V(on) 3.3(off) => 0x6
    write_abs_uint("MMCHS1.MMCHS_CAPA", 0x4809C140, *ret | 0x04000000); // 1.8V(on) 3V(off) 3.3(off) => 0x4

      // power on 3V here?
    read_abs_uint("MMCHS_HCTL", 0x4809C128 , ret);
    //write_abs_uint("MMCHS_HCTL", 0x4809C128 , (*ret & (~(1<<5))) | (1<<8) | (1<<7) | (1<<6)); // 3V
    //write_abs_uint("MMCHS_HCTL", 0x4809C128 , (*ret & (~(1<<7))) | (1<<8) | (1<<5) | (1<<6)); // 1.8V? wrong bits
    //write_abs_uint("MMCHS_HCTL", 0x4809C128 , *ret | (0x6 << 9)); //3.0V? wrong bits
    write_abs_uint("MMCHS_HCTL", 0x4809C128 , *ret | (0x5 << 9)); // 1.8V? wrong bits
    read_abs_uint("MMCHS_HCTL", 0x4809C128 , ret);
    write_abs_uint("MMCHS_HCTL", 0x4809C128 , *ret | (1<<8)); // split is in kmod

    
    read_abs_uint("PRM_VOLTCTRL", 0x48307260, ret);
    write_abs_uint("PRM_VOLTCTRL", 0x48307260, *ret | (1<<4)); // enable VMODE


    
    read_abs_uint("CONTROL_PBIAS_LITE", 0x48002520 , ret);
    write_abs_uint("CONTROL_PBIAS_LITE", 0x48002520 , *ret & ~(0x2) ); // set 0
  
    read_abs_uint("CONTROL_PBIAS_LITE", 0x48002520 , ret);
    write_abs_uint("CONTROL_PBIAS_LITE", 0x48002520 , *ret & ~(0x1) ); // clear 3V -> 1.8V

    read_abs_uint("CONTROL_PBIAS_LITE", 0x48002520 , ret);
    write_abs_uint("CONTROL_PBIAS_LITE", 0x48002520 , *ret | (0x2) ); // declare stable

    
    // going Systestmode
    read_abs_uint("MMCHS1.MMCHS_CON", 0x4809C02C, ret);
    write_abs_uint("MMCHS1.MMCHS_CON", 0x4809C02C, *ret | 1 << 4);
  }

  
  read_abs_uint("MMCHS_SYSTEST",  0x4809C028, ret);

  
  gpio = 1 << 0 | 1 << 4 | 1 << 5 | 1 << 6 | 1 << 7 | 1 << 8 | 1 << 9 | 1 << 10 | 1 << 11;

  // 4 pin dat0/pin7, 5 pin dat1/pin8, 6 pin dat2/pin1 , 7 pin dat3/pin2
  gpio = 1 << 0 | 1 << 6 | 1 << 5;
  //gpio = 1 << 0 | 1 << 4 ;
  //pin 1
  gpio = 1 << 0 | 1 << 6 ;
  write_abs_uint("MMCHS_SYSTEST",  0x4809C028, gpio);
  read_abs_uint("MMCHS_SYSTEST",  0x4809C028, ret);


  //write_abs_uint("MMCHS_SYSTEST",  0x4809C028, 0);
  /*
  // power on 3V working here 3V only
  read_abs_uint("MMCHS_HCTL", 0x4809C128 , ret);
  //write_abs_uint("MMCHS_HCTL", 0x4809C128 , *ret | (1<<8) | (~(1<<5)) & ((1<<7) | (1<<6))); // 3V
  write_abs_uint("MMCHS_HCTL", 0x4809C128 , *ret | (1<<8) | (~(1<<7)) & ((1<<5) | (1<<6))); // 1.8V?
  */


}


void off(){
  unsigned int* ret = malloc(sizeof(int));
  write_abs_uint("MMCHS_SYSTEST",  0x4809C028, 0 | (1<< 15)); // card detect high?
    //reset
  write_abs_uint("MMCHS1.MMCHS_SYSCONFIG", 0x4809C010, 0x00000002);

  // leave testmode
  for (read_abs_uint("MMCHS1.MMCHS_SYSSTATUS", 0x4809C014, ret); (*ret & 1) != 1;usleep(100000))
    read_abs_uint("MMCHS1.MMCHS_SYSSTATUS", 0x4809C014, ret);

  read_abs_uint("MMCHS1.MMCHS_CAPA", 0x4809C140, ret); // , current_value | 0x06000000
  //write_abs_uint("MMCHS1.MMCHS_CAPA", 0x4809C140, *ret | 0x06000000); // 1.8V(on) 3V(on) 3.3(off) => 0x6
  write_abs_uint("MMCHS1.MMCHS_CAPA", 0x4809C140, *ret & ~(0x07000000));
  
  // power 1.8, 3, 3.3 off 
  write_abs_uint("MMCHS_HCTL", 0x4809C128 , 0);
  
  /* no */
  read_abs_uint("MMCHS1.MMCHS_CON", 0x4809C02C, ret);
  write_abs_uint("MMCHS1.MMCHS_CON", 0x4809C02C, *ret & ~(1 << 4));
  /* */


  /* no */
  read_abs_uint("PRCM.CM_FCLKEN1_CORE", 0x48004A00, ret);
  write_abs_uint("PRCM.CM_FCLKEN1_CORE", 0x48004A00, *ret & ~(0x01000000));
  read_abs_uint("PRCM.CM_ICLKEN1_CORE", 0x48004A10, ret);
  write_abs_uint("PRCM.CM_ICLKEN1_CORE", 0x48004A10, *ret & ~(0x01000000));  
  /* */

  
}

int main()
{
  init();
  //off();
  // read_abs(mmcsh1_phy_addr);
  //read_abs(mmcsh2_phy_addr);
  //read_abs(mmcsh3_phy_addr);

  
  // read_abs(mmcsh1_capa_phy_addr);
  //read_abs(mmcsh2_capa_phy_addr);
  //read_abs(mmcsh3_capa_phy_addr);
  

  return 0;
}
